/*

        Flog 0.15


                                        ani joshi

*/



#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include "flist.h"
#include "filelist.h"
#include "emaillist.h"

// prototypes are good programming style :)
void usage(); 

void usage(){
	cerr << "Usage:\n";
	cerr << "\t./flog [options]\n";
	cerr << "Options:\n";
	cerr << "\t-f or --file /path/to/file\n";
	cerr << "\t            - if file is in current path then just do -f xferlog\n";
	cerr << "\t-h or --help\n";
	cerr << "\t            - to see this help screen\n";
	cerr << "\t-v or --version\n";
	cerr << "\t            - to see version information\n";
	return;
}

int main(int argc, char *argv[]){
	cerr << "flog  0.15 \t3.25.99\ncopyleft (c) 1999 - Ani Joshi <ajoshi@wam.umd.edu>\n\n";
	char *filename="/var/log/xferlog";
	if(argc>1){
		if(strcmp("-f",argv[1])!=0 && strcmp("--file",argv[1])!=0
		 && strcmp("-h",argv[1])!=0 && strcmp("--help",argv[1])!=0
		 && strcmp("-v",argv[1])!=0 && strcmp("--version",argv[1])!=0){
			usage();
			return 0;
		}
		if(strcmp("-f",argv[1])==0 || strcmp("--file",argv[1])==0)
			filename=argv[2];
		if(strcmp("-h",argv[1])==0 || strcmp("--help",argv[1])==0){
			usage();
			return 0;
		}
		if(strcmp("-v",argv[1])==0 || strcmp("--version",argv[1])==0){
			cerr << "flog  v.0.15\n";
			return 0;
		}
	}
	Flist list;
	Filelist filelist;
	Emaillist emaillist;
	Filelistnode luckyfilenode;
	Emaillistnode luckyemailnode;
	struct stat *buff,buffer;
	Logline l;
	ifstream in;
	in.open(filename);
	if(!in){
		cerr << "\nFile not found or you don't have permissions to read the file.\n";
		return 0;
	}
	buff=&buffer;
	stat(filename,buff);
	double bufsize;
	bufsize=buffer.st_size;
	int x=0,avgsize=152,maxhits,maxemailhits;
	float tiny=(avgsize/bufsize)*100,percentdone;
	cerr << "Reading data from xferlog...\n";
	int perdone=0,temptime,z=0;
	while(!in.eof()){
		x++;
		percentdone=((x*avgsize)/bufsize)*100;
		if(percentdone>(perdone+9+tiny) && percentdone<(perdone+10+tiny) && perdone!=90){
			perdone+=10;
			cerr << "...." << perdone << '%';
		}
		l.read(in);
		list.add(l);
		in >> ws;
		if(in.eof()) break;
	}
	cerr << "....100%\nDone reading\n\n\n";
	String temp,fastemail,fastip,tempfilename,luckyfile,tempemail,luckyemail;
	list.go_first();
	double tempsize,totalsize=0,totalmegs,temp4;
	float maxspeed=0,tempspeed;
	cerr << "Analyzing data...\n";
	tiny=(1/x);
	x=0;
	percentdone=0;
	perdone=0;
	while(!list.is_off_list()){
		x++;
		percentdone=((x*avgsize)/bufsize)*100;
		if(percentdone>(perdone+9+tiny) && percentdone<(perdone+10+tiny) && perdone!=90){
			perdone+=10;
			cerr << "...." << perdone << '%';
		}
		tempfilename=list.get_current().get_filename();
		tempemail=list.get_current().get_email();
		if(filelist.locate(tempfilename))
			filelist.inc_hits();
		else
			filelist.add(tempfilename);
		if(emaillist.locate(tempemail))
			emaillist.inc_hits();
		else
			emaillist.add(tempemail);
		tempsize=list.get_current().get_xfersize();
		temptime=list.get_current().get_xfertime();
		tempspeed=tempsize/temptime;
		tempspeed=tempspeed/1000;
		if(maxspeed<tempspeed && tempspeed<1000){
			maxspeed=tempspeed;
			fastemail=list.get_current().get_email();
			fastip=list.get_current().get_ip();
		}
		totalsize+=tempsize;
		list.go_next();
	}
	cerr << "....100%\nDone analying\n\n\n";
	luckyfilenode=filelist.get_lucky_one();
	luckyfile=luckyfilenode.filename;
	maxhits=luckyfilenode.hits;
	luckyemailnode=emaillist.get_lucky_one();
	luckyemail=luckyemailnode.email;
	maxemailhits=luckyemailnode.hits;
	totalsize=totalsize/1024;
	if(totalsize<1000){
		totalmegs=totalsize;
		cout << "Total bytes xfered:\t\t" << totalmegs << " kb" << endl;
	}
	else if(totalsize<1024000){
		totalmegs=(totalsize/1000);
		cout << "Total bytes xfered:\t\t" << totalmegs << " megs" << endl;
	}
	else {
		totalmegs=(totalsize/1024000);
		cout << "Total bytes xfered:\t\t" << totalmegs << " gigs" << endl;
	}
	cout << "Total files xfered:\t\t" << x << endl;
	temp4=(totalsize/x);
	if(temp4<1000){
		cout.setf(ios::fixed,ios::floatfield);
		cout << setprecision(2) << "Avgerage file size xfered:\t" << temp4 << " kb\n";
	}
	else {
		temp4=(temp4/1024);
		cout.setf(ios::fixed,ios::floatfield);
		cout << setprecision(2) << "Avgerage file size xfered:\t" << temp4 << " mb\n";
	}
	cout << setprecision(2) <<"Fastest xfer:\t" << maxspeed << " kb/sec ";
	cout << " set by " << fastemail << ' ' << endl;
	cout << "Fastest xfer from the machine at:\t" << fastip << endl;
	cout << maxhits << " requests for:  " << luckyfile << endl;
	cout << maxemailhits << " files grabbed by:  " << luckyemail << endl << endl;

	return 0;
}

